MCP Tools Reference: apihub.googleapis.com

Tool: list_specs

List specs corresponding to a particular API resource.

The following sample demonstrate how to use curl to invoke the list_specs MCP tool.

Curl Request
                  
curl --location 'https://apihub.REGION.rep.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "list_specs",
    "arguments": {
      // provide these details according to the tool's MCP specification
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'
                

Where, REGION is the supported API hub region. For more information, see Supported regions.

Input Schema

The [ListSpecs][ListSpecs] method's request.

ListSpecsRequest

JSON representation
{
  "parent": string,
  "filter": string,
  "pageSize": integer,
  "pageToken": string
}
Fields
parent

string

Required. The parent, which owns this collection of specs. Format: projects/{project}/locations/{location}/apis/{api}/versions/{version}

filter

string

Optional. An expression that filters the list of Specs.

A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string. The comparison operator must be one of: <, >, : or =. Filters are not case sensitive.

The following fields in the Spec are eligible for filtering:

  • display_name - The display name of the Spec. Allowed comparison operators: =.
  • create_time - The time at which the Spec was created. The value should be in the (RFC3339)[https://tools.ietf.org/html/rfc3339] format. Allowed comparison operators: > and <.
  • spec_type.enum_values.values.id - The allowed value id of the spec_type attribute associated with the Spec. Allowed comparison operators: :.
  • spec_type.enum_values.values.display_name - The allowed value display name of the spec_type attribute associated with the Spec. Allowed comparison operators: :.
  • lint_response.json_values.values - The json value of the lint_response attribute associated with the Spec. Allowed comparison operators: :.
  • mime_type - The MIME type of the Spec. Allowed comparison operators: =.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.enum_values.values.id - The allowed value id of the user defined enum attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-enum-id is a placeholder that can be replaced with any user defined enum attribute name.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.enum_values.values.display_name
  • The allowed value display name of the user defined enum attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-enum-display-name is a placeholder that can be replaced with any user defined enum attribute enum name.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.string_values.values - The allowed value of the user defined string attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-string is a placeholder that can be replaced with any user defined string attribute name.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.json_values.values - The allowed value of the user defined JSON attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-json is a placeholder that can be replaced with any user defined JSON attribute name.

Expressions are combined with either AND logic operator or OR logical operator but not both of them together i.e. only one of the AND or OR operator can be used throughout the filter string and both the operators cannot be used together. No other logical operators are supported. At most three filter fields are allowed in the filter string and if provided more than that then INVALID_ARGUMENT error is returned by the API.

Here are a few examples:

  • spec_type.enum_values.values.id: rest-id - The filter string specifies that the id of the allowed value associated with the spec_type attribute is rest-id.
  • spec_type.enum_values.values.display_name: \"Rest Display Name\" - The filter string specifies that the display name of the allowed value associated with the spec_type attribute is Rest Display Name.
  • spec_type.enum_values.values.id: grpc-id AND create_time < \"2021-08-15T14:50:00Z\" AND create_time > \"2021-08-10T12:00:00Z\" - The id of the allowed value associated with the spec_type attribute is grpc-id and the spec was created before 2021-08-15 14:50:00 UTC and after 2021-08-10 12:00:00 UTC.
  • spec_type.enum_values.values.id: rest-id OR spec_type.enum_values.values.id: grpc-id
  • The id of the allowed value associated with the spec_type attribute is rest-id or grpc-id.
  • spec_type.enum_values.values.id: rest-id AND attributes.projects/test-project-id/locations/test-location-id/ attributes/17650f90-4a29-4971-b3c0-d5532da3764b.enum_values.values.id: test - The filter string specifies that the id of the allowed value associated with the spec_type attribute is rest-id and the id of the allowed value associated with the user defined attribute of type enum is test.
pageSize

integer

Optional. The maximum number of specs to return. The service may return fewer than this value. If unspecified, at most 50 specs will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000.

pageToken

string

Optional. A page token, received from a previous ListSpecs call. Provide this to retrieve the subsequent page.

When paginating, all other parameters provided to ListSpecs must match the call that provided the page token.

Output Schema

The ListSpecs method's response.

ListSpecsResponse

JSON representation
{
  "specs": [
    {
      object (Spec)
    }
  ],
  "nextPageToken": string
}
Fields
specs[]

object (Spec)

The specs corresponding to an API Version.

nextPageToken

string

A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

Spec

JSON representation
{
  "name": string,
  "displayName": string,
  "specType": {
    object (AttributeValues)
  },
  "contents": {
    object (SpecContents)
  },
  "details": {
    object (SpecDetails)
  },
  "sourceUri": string,
  "createTime": string,
  "updateTime": string,
  "lintResponse": {
    object (LintResponse)
  },
  "attributes": {
    string: {
      object (AttributeValues)
    },
    ...
  },
  "documentation": {
    object (Documentation)
  },
  "parsingMode": enum (ParsingMode),
  "sourceMetadata": [
    {
      object (SourceMetadata)
    }
  ],
  "additionalSpecContents": [
    {
      object (AdditionalSpecContent)
    }
  ]
}
Fields
name

string

Identifier. The name of the spec.

Format: projects/{project}/locations/{location}/apis/{api}/versions/{version}/specs/{spec}

displayName

string

Required. The display name of the spec. This can contain the file name of the spec.

specType

object (AttributeValues)

Required. The type of spec. The value should be one of the allowed values defined for projects/{project}/locations/{location}/attributes/system-spec-type attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API.

Note, this field is mandatory if content is provided.

contents

object (SpecContents)

Optional. Input only. The contents of the uploaded spec.

details

object (SpecDetails)

Output only. Details parsed from the spec.

sourceUri

string

Optional. The URI of the spec source in case file is uploaded from an external version control system.

createTime

string (Timestamp format)

Output only. The time at which the spec was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. The time at which the spec was last updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

lintResponse

object (LintResponse)

Optional. The lint response for the spec.

attributes

map (key: string, value: object (AttributeValues))

Optional. The list of user defined attributes associated with the spec. The key is the attribute name. It will be of the format: projects/{project}/locations/{location}/attributes/{attribute}. The value is the attribute values associated with the resource.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

documentation

object (Documentation)

Optional. The documentation of the spec. For OpenAPI spec, this will be populated from externalDocs in OpenAPI spec.

parsingMode

enum (ParsingMode)

Optional. Input only. Enum specifying the parsing mode for OpenAPI Specification (OAS) parsing.

sourceMetadata[]

object (SourceMetadata)

Output only. The list of sources and metadata from the sources of the spec.

additionalSpecContents[]

object (AdditionalSpecContent)

Output only. The additional spec contents for the spec.

AttributeValues

JSON representation
{
  "attribute": string,

  // Union field Value can be only one of the following:
  "enumValues": {
    object (EnumAttributeValues)
  },
  "stringValues": {
    object (StringAttributeValues)
  },
  "jsonValues": {
    object (StringAttributeValues)
  },
  "uriValues": {
    object (StringAttributeValues)
  }
  // End of list of possible types for union field Value.
}
Fields
attribute

string

Output only. The name of the attribute. Format: projects/{project}/locations/{location}/attributes/{attribute}

Union field Value. The attribute values associated with the resource. Value can be only one of the following:
enumValues

object (EnumAttributeValues)

The attribute values associated with a resource in case attribute data type is enum.

stringValues

object (StringAttributeValues)

The attribute values associated with a resource in case attribute data type is string.

jsonValues

object (StringAttributeValues)

The attribute values associated with a resource in case attribute data type is JSON.

uriValues

object (StringAttributeValues)

The attribute values associated with a resource in case attribute data type is URL, URI or IP, like gs://bucket-name/object-name.

EnumAttributeValues

JSON representation
{
  "values": [
    {
      object (AllowedValue)
    }
  ]
}
Fields
values[]

object (AllowedValue)

Required. The attribute values in case attribute data type is enum.

AllowedValue

JSON representation
{
  "id": string,
  "displayName": string,
  "description": string,
  "immutable": boolean
}
Fields
id

string

Required. The ID of the allowed value. * If provided, the same will be used. The service will throw an error if the specified id is already used by another allowed value in the same attribute resource. * If not provided, a system generated id derived from the display name will be used. In this case, the service will handle conflict resolution by adding a system generated suffix in case of duplicates.

This value should be 4-63 characters, and valid characters are /[a-z][0-9]-/.

displayName

string

Required. The display name of the allowed value.

description

string

Optional. The detailed description of the allowed value.

immutable

boolean

Optional. When set to true, the allowed value cannot be updated or deleted by the user. It can only be true for System defined attributes.

StringAttributeValues

JSON representation
{
  "values": [
    string
  ]
}
Fields
values[]

string

Required. The attribute values in case attribute data type is string or JSON.

SpecContents

JSON representation
{
  "contents": string,
  "mimeType": string
}
Fields
contents

string (bytes format)

Required. The contents of the spec.

A base64-encoded string.

mimeType

string

Required. The mime type of the content for example application/json, application/yaml, application/wsdl etc.

SpecDetails

JSON representation
{
  "description": string,

  // Union field details can be only one of the following:
  "openApiSpecDetails": {
    object (OpenApiSpecDetails)
  }
  // End of list of possible types for union field details.
}
Fields
description

string

Output only. The description of the spec.

Union field details.

details can be only one of the following:

openApiSpecDetails

object (OpenApiSpecDetails)

Output only. Additional details apart from OperationDetails parsed from an OpenAPI spec. The OperationDetails parsed from the spec can be obtained by using ListAPIOperations method.

OpenApiSpecDetails

JSON representation
{
  "format": enum (Format),
  "version": string,
  "owner": {
    object (Owner)
  }
}
Fields
format

enum (Format)

Output only. The format of the spec.

version

string

Output only. The version in the spec. This maps to info.version in OpenAPI spec.

owner

object (Owner)

Output only. Owner details for the spec. This maps to info.contact in OpenAPI spec.

Owner

JSON representation
{
  "displayName": string,
  "email": string
}
Fields
displayName

string

Optional. The name of the owner.

email

string

Required. The email of the owner.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

LintResponse

JSON representation
{
  "issues": [
    {
      object (Issue)
    }
  ],
  "summary": [
    {
      object (SummaryEntry)
    }
  ],
  "state": enum (LintState),
  "source": string,
  "linter": enum (Linter),
  "createTime": string
}
Fields
issues[]

object (Issue)

Optional. Array of issues found in the analyzed document.

summary[]

object (SummaryEntry)

Optional. Summary of all issue types and counts for each severity level.

state

enum (LintState)

Required. Lint state represents success or failure for linting.

source

string

Required. Name of the linting application.

linter

enum (Linter)

Required. Name of the linter used.

createTime

string (Timestamp format)

Required. Timestamp when the linting response was generated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Issue

JSON representation
{
  "code": string,
  "path": [
    string
  ],
  "message": string,
  "severity": enum (Severity),
  "range": {
    object (Range)
  }
}
Fields
code

string

Required. Rule code unique to each rule defined in linter.

path[]

string

Required. An array of strings indicating the location in the analyzed document where the rule was triggered.

message

string

Required. Human-readable message describing the issue found by the linter.

severity

enum (Severity)

Required. Severity level of the rule violation.

range

object (Range)

Required. Object describing where in the file the issue was found.

Range

JSON representation
{
  "start": {
    object (Point)
  },
  "end": {
    object (Point)
  }
}
Fields
start

object (Point)

Required. Start of the issue.

end

object (Point)

Required. End of the issue.

Point

JSON representation
{
  "line": integer,
  "character": integer
}
Fields
line

integer

Required. Line number (zero-indexed).

character

integer

Required. Character position within the line (zero-indexed).

SummaryEntry

JSON representation
{
  "severity": enum (Severity),
  "count": integer
}
Fields
severity

enum (Severity)

Required. Severity of the issue.

count

integer

Required. Count of issues with the given severity.

AttributesEntry

JSON representation
{
  "key": string,
  "value": {
    object (AttributeValues)
  }
}
Fields
key

string

value

object (AttributeValues)

Documentation

JSON representation
{
  "externalUri": string
}
Fields
externalUri

string

Optional. The uri of the externally hosted documentation.

SourceMetadata

JSON representation
{
  "sourceType": enum (SourceType),
  "originalResourceId": string,
  "originalResourceCreateTime": string,
  "originalResourceUpdateTime": string,

  // Union field source can be only one of the following:
  "pluginInstanceActionSource": {
    object (PluginInstanceActionSource)
  }
  // End of list of possible types for union field source.
}
Fields
sourceType

enum (SourceType)

Output only. The type of the source.

originalResourceId

string

Output only. The unique identifier of the resource at the source.

originalResourceCreateTime

string (Timestamp format)

Output only. The time at which the resource was created at the source.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

originalResourceUpdateTime

string (Timestamp format)

Output only. The time at which the resource was last updated at the source.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field source. The source of the resource. source can be only one of the following:
pluginInstanceActionSource

object (PluginInstanceActionSource)

Output only. The source of the resource is a plugin instance action.

PluginInstanceActionSource

JSON representation
{
  "pluginInstance": string,
  "actionId": string
}
Fields
pluginInstance

string

Output only. The resource name of the source plugin instance. Format is projects/{project}/locations/{location}/plugins/{plugin}/instances/{instance}

actionId

string

Output only. The id of the plugin instance action.

AdditionalSpecContent

JSON representation
{
  "specContentType": enum (SpecContentType),
  "specContents": {
    object (SpecContents)
  },
  "createTime": string,
  "updateTime": string,
  "labels": {
    string: string,
    ...
  }
}
Fields
specContentType

enum (SpecContentType)

Required. The type of the spec content.

specContents

object (SpecContents)

Optional. The additional spec contents.

createTime

string (Timestamp format)

Output only. The time at which the spec content was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. The time at which the spec content was last updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

labels

map (key: string, value: string)

Optional. The labels of the spec content e.g. specboost addon version.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

LabelsEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

Tool Annotations

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌